GGATED(8)

NAME
ggated - GEOM Gate network daemon

SYNOPSIS
ggated [-h] [-n] [-v] [-a address] [-p port] [-F pidfile] [-R rcvbuf] [-S sndbuf] [exports file]

DESCRIPTION
The ggated utility is a network server for the GEOM Gate class. It runs on a server machine to service GEOM Gate requests from workers placed on a client machine. Keep in mind, that connections between ggatec(8) and ggated are not encrypted.

Available options:

-a address
    Specifies an IP address to bind to.

-h  Print available options.

-n  Do not use TCP_NODELAY option on TCP sockets.

-p port
    Port on which ggated listens for connections. Default is 3080.

-F pidfile
    PID file that ggated uses.

-R rcvbuf
    Size of receive buffer to use. Default is 131072 (128 KiB).

-S sndbuf
    Size of send buffer to use. Default is 131072 (128 KiB).

-v  Do not fork, run in foreground and print debug information on standard output.

exports file
    An alternate location for the exports file.

The format of an exports file is as follows:

    1.2.3.4		RO		/dev/cd0
    1.2.3.0/24	RW		/tmp/test.img
    hostname	WO		/tmp/image
    hostname	RW,DIRECT	/tmp/direct-image
    hostname	RW,NODIRECT	/tmp/nodirect-image

The first colunm specifies the ip, network with netmask, or the hostname that the export applies to.

The next column is the access flags that apply to the export

RO  Read-Only the path specified will be exported to the client read only.

WO  Write-Only the path specified will be exported to the client write only.

RW  Read-Write the path specified will be exported to the client read-write.

DIRECT
    The path specified will always be opened with O_DIRECT for clients.

NODIRECT
    The path specified will never be opened with O_DIRECT for clients.

The final column specifies the path to export.

Files are opened with the least common flags between the client and the server. A client may request read or write only to a read-write export and the server will honor the client request and open the file in the requested mode. A client requesting greater access than permissions listed in the file will be rejected.

DIRECT and NODIRECT are used to coerce the use of the O_DIRECT flag to open(2) when the specified path is opened. If DIRECT is specified the path is always opened with O_DIRECT. If NODIRECT is specified the path is never opened with O_DIRECT. DIRECT access limits the cache effects of IO operaions on the file. This has the effect of having clients accessing exports to not impact the cache of the local machine, however it will cause greater IO utilization to the devices on which the files reside.

If neither is specified the server will use the preference specified by the client, with the default to not use O_DIRECT. If the client specifies a preference against the server's configuration the client preference will be silently ignored.

FILES
/var/run/ggated.pid
    The default location of the ggated PID file.

EXIT STATUS
Exit status is 0 on success, or 1 if the command fails. To get details about the failure, ggated should be called with the -v option.

EXAMPLES
Export CD-ROM device, a file, and a file with O_DIRECT option:

    # echo "1.2.3.0/24 RO /dev/cd0" > /etc/gg.exports
    # echo "client RW /image" >> /etc/gg.exports
    # echo "client RW,DIRECT /image2" >> /etc/gg.exports
    # echo "client RW,NODIRECT /image3" >> /etc/gg.exports
    # ggated

SEE ALSO
open(2), geom(4), ggatec(8), ggatel(8)

HISTORY
The ggated utility appeared in FreeBSD 5.3.

AUTHORS
The ggated utility as well as this manual page was written by Pawel Jakub Dawidek <pjd@FreeBSD.org>.